Ext.define('DSS.editor.CombinedStateEditorPart', {
	extend : 'DSS.component.Base',
	macGridHeight:217,
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 0;
	},
	startEdit: function() {
		this.selectedID=null;
		this.macPanel.expand();
		this.constructLVL1();
	},
	takeOverAKM: function (dsuid,index,value) {
		if (this.selectedID==null) {
			// new entry

			var state="dev." + dsuid + "." + index;
			if (value===dss.whState.WH_Closed) {
				value="closed";
			} else
				if (value===dss.whState.WH_Open) {
					value="open";
				} else
					if (value===dss.whState.WH_Tilted) {
						value="tilted";
					} else
						if (value) {
							value="active";
						} else {
							value="inactive";
						}
			
			this.selectedID=((new Date()).getTime());
			var oDataObject={
				state:state,
				value:value,
				number:this.selectedID,
				addonid:''
			};
			this.grid.store.add(oDataObject);
		} else {			
			var record=this.grid.store.findRecord('number',this.selectedID,0,false,true,true);
			
			var state="dev." + dsuid + "." + index;
			if (value===dss.whState.WH_Closed) {
				value="closed";
			} else
				if (value===dss.whState.WH_Open) {
					value="open";
				} else
					if (value===dss.whState.WH_Tilted) {
						value="tilted";
					} else
						if (value) {
							value="active";
						} else {
							value="inactive";
						}

			if (record!=null) {
				record.set("state",state);
				record.set("value",value);
				record.set("addonid",'');
				record.commit();
			}
		}
	},
	takeOver: function (state,value,addonid) {
		if (this.selectedID==null) {
			// new entry
			this.selectedID=((new Date()).getTime());
			var oDataObject={
				state:state,
				value:value,
				number:this.selectedID,
				addonid:addonid
			};
			this.grid.store.add(oDataObject);
		} else {
			var record=this.grid.store.findRecord('number',this.selectedID,0,false,true,true);
			if (record!=null) {
				record.set("state",state);
				record.set("value",value);
				record.set("addonid",addonid);
				record.commit();
			}
		}
	},
	selectedID:null,
    getDeviceAKMStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('combinedState_deviceAKMStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_deviceAKMStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getAKMDeviceArray();
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((ZoneID==0) || (ZoneID==oDeviceArray[iIndex].ZoneID))     
                	Ext.data.StoreManager.lookup('combinedState_deviceAKMStore_' + ZoneID).add(oDeviceArray[iIndex]);
            }
        }        
        return Ext.data.StoreManager.lookup('combinedState_deviceAKMStore_' + ZoneID);
    },
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false; 
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))   // ist ein device -> weiterbutton
        {
            fHasNext=true;
            var sTooltip=dss.staticDataModel.getTooltipForDevice(dss.staticDataModel.getDevice(record.get('dSUID')));
            if (sTooltip!="")
            	metadata.tdAttr = 'data-qtip="'+sTooltip+'"';
        }
        if (record.get('tooltip')!=null) {
        	if (record.get('tooltip')!="")
        		metadata.tdAttr = 'data-qtip="' + record.get('tooltip') + '"';
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) {
            fHasNext=false; // checkboxen niemals weiterbuttons
            fHasIcon=false; // keine Icons nach Checkboxen
            fIsCheckable=true;
        }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }
        
        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';      
    },
    constructGridLvlRoomStateState: function (zoneID) {
    	var oStates=dss.staticDataModel.getStates();
    	var oShowStates=[];
    	for (var iIndex=0;iIndex<oStates.length;iIndex++) {
    		var sSplitName=oStates[iIndex].name.split(".");
    		if (sSplitName.length==3)
    			if (sSplitName[0]=='zone')
    				if ((sSplitName[1]==''+zoneID) && (sSplitName[2] != 'heating')){
    					oShowStates.push(oStates[iIndex]);
    				}
    	}
    	oShowStates.sort(function (o1,o2) {if (o1.name<o2.name)return -1; else return 1;});
    		
        var oRoomStateStateControlStore = Ext.create('Ext.data.Store', {
            fields : [  'name','stateid','value','icon','tooltip','valueandstate'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oNewArray=[];
    	for (var iIndex=0;iIndex<oShowStates.length;iIndex++) {
    		var oNameArray=oShowStates[iIndex].name.split('.');
            var oItem={
            		'stateid':oShowStates[iIndex].name,
            		'value':'active',
            		'tooltip':"",
            		'icon': "",
            		'valueandstate':oShowStates[iIndex].name+'_active'};
            if (oNameArray[2]=='light') {
            	oItem.icon=dss.staticDataModel.getImagePathForScene(0,1,5);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}light is active"),{});
            }            	
            else if (oNameArray[2]=='motion') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(5,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}motion is active"),{});
            }            	
            else if (oNameArray[2]=='presence') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(1,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}presence is active"),{});
            }            	
            else {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(0,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}{state} is active"),{'state':oNameArray[2]});
            }            	
            oNewArray.push(oItem);
            
            oItem={
            		'stateid':oShowStates[iIndex].name,
            		'value':'inactive',
            		'tooltip':"",
            		'icon': "",
            		'valueandstate':oShowStates[iIndex].name+'_inactive'};
            if (oNameArray[2]=='light') {
            	oItem.icon=dss.staticDataModel.getImagePathForScene(0,1,0);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}light is inactive"),{});
            }
            else if (oNameArray[2]=='motion') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(5,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}motion is inactive"),{});
            }
            else if (oNameArray[2]=='presence') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(1,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}presence is inactive"),{});
            }            	
            else {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(0,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}{state} is inactive"),{'state':oNameArray[2]});
            }            	
            oNewArray.push(oItem);            
    	}
        oRoomStateStateControlStore.add(oNewArray);

    	this.grids.lvlRoomStateState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 239,
            width : 434,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomStateStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : this.defMacGridRenderer                
            } ]
        });

        this.grids.lvlRoomStateState.parent = this;
         
        
        var me=this;

        
	    this.grids.lvlRoomStateState.on('itemclick', function(grid, record) {
            this.getSelectionModel().deselectAll();
            this.getSelectionModel().select(record);
        	this.parent.takeOver (record.get('stateid'),record.get('value'),'');              
        });
        
        this.grids.lvlRoomStateState.on('itemdblclick', function(grid, record) {
            this.getSelectionModel().deselectAll();
            this.getSelectionModel().select(record);
        	this.parent.takeOver (record.get('stateid'),record.get('value'),'');
        	this.parent.macPanel.collapse();
        });	    	   
        
        this.macPanel.add(this.grids.lvlRoomStateState);
    	
    },
    constructGridLvlRoom: function() {
    	var oRoomStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('combinedState_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
            	oRoomStateControlStore.add(oNewRecord);
        });
        oRoomStateControlStore.sort('name');
      
        this.grids.lvlRoomStateRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
	        height : 239,
	        width : 150,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoomStateRoom.parent = this;
        this.grids.lvlRoomStateRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateState);
           
            var zoneID = record.get('ZoneID');
            this.parent.constructGridLvlRoomStateState(zoneID);           
        });
        this.macPanel.add(this.grids.lvlRoomStateRoom);
    },
    constructGridLvlDeviceAKMValue: function(dSUID, type) {
    	var oStore = Ext.create('Ext.data.Store', {
	        fields : [ 'name','_id','next','icon','tooltip','index' ],
	        proxy : {
	            type : 'memory',
	            reader : {
	                type : 'json',
	                root : 'items'
	            }
	        }
	    });
	
	    var oDevice=dss.staticDataModel.getDevice(dSUID);
	    if (dss.staticDataModel.getDeviceType(oDevice) == 10) { //TNY
	        for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
	            if (oDevice.binaryInputs[iIndex].type == type) {
	                var oItem={
	                        'index':oDevice.binaryInputs[iIndex].index,
	                        'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
	                        '_id':false,
	                        'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
	                        'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false)};
	                oStore.add(oItem);
	                oItem={
	                        'index':oDevice.binaryInputs[iIndex].index,
	                        'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
	                        '_id':true,
	                        'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
	                        'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true)};
	                oStore.add(oItem);
	            }
	        }
	        
	    } else {
	        var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);
	        for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
	            if (!bIsWindowHandle) {
	                var oItem={
	                        'index':oDevice.binaryInputs[iIndex].index,
	                        'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
	                        '_id':false,
	                        'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
	                        'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false)};
	                oStore.add(oItem);
	
	                oItem={
	                        'index':oDevice.binaryInputs[iIndex].index,
	                        'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
	                        '_id':true,
	                        'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
	                        'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true)};
	                oStore.add(oItem);
	            } else {
	                if (oDevice.binaryInputs[iIndex].type == 15)  { // BinaryInputIDWindowTilt
	                    var oItem={
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Closed),
	                            '_id':dss.whState.WH_Closed,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Closed),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Closed),
	                            'index':oDevice.binaryInputs[iIndex].index};
	                    oStore.add(oItem);
	                    oItem={
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Open),
	                            '_id':dss.whState.WH_Open,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Open),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Open),
	                            'index':oDevice.binaryInputs[iIndex].index};
	                    oStore.add(oItem);
	                    oItem={
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Tilted),
	                            '_id':dss.whState.WH_Tilted,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Tilted),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Tilted),
	                            'index':oDevice.binaryInputs[iIndex].index};
	                    oStore.add(oItem);
	                }
	            }
	        }
	    }
	    this.grids.lvlDeviceAKMValue = Ext.create('Ext.grid.Panel', {
	        hideHeaders:true,
	        height : 239,
	        width : 284,//150 + 174,
	        autoScroll : true,
	        viewConfig : {
	            stripeRows : true
	        },           
	        store : oStore,
	        columns : [ {
	            sortable : false,
	            hideable : false,
	            text : _('type'),
	            dataIndex : 'name',
	            flex : 1,
	            renderer : this.defMacGridRenderer
	        } ]
	    });
	    var me=this;
	
	    this.grids.lvlDeviceAKMValue.on('itemclick', function(grid, record) {
            this.getSelectionModel().deselectAll();
            this.getSelectionModel().select(record);
        	this.parent.takeOverAKM(this.parent.grids.lvlAKMDevice.getSelectionModel().getSelection()[0].get('dSUID'),record.get('index'),record.get('_id'));              
        });
        
        this.grids.lvlDeviceAKMValue.on('itemdblclick', function(grid, record) {
        	this.parent.takeOverAKM(this.parent.grids.lvlAKMDevice.getSelectionModel().getSelection()[0].get('dSUID'),record.get('index'),record.get('_id')); 
        	this.parent.macPanel.collapse();
        });
	    	   
	    this.grids.lvlDeviceAKMValue.parent = this;
	
	    this.macPanel.add(this.grids.lvlDeviceAKMValue);
    },
    constructGridLvlDeviceAKMs: function (zoneID) {
    	var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getDeviceAKMStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('present')) {
                var oDevice = dss.staticDataModel.getDevice(oNewRecord.get('dSUID'));
                if (dss.staticDataModel.getDeviceType(oDevice) == 10 /*TNY*/) {
                    for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++) {
                            type=oDevice.binaryInputs[kIndex].type;
                            if (type!=255) {
                                var oInput = oNewRecord.copy();
                                var typeName = dss.staticDataModel.getNameForAKMType(type);
                                oInput.data.name = typeName;
                                oInput.data.type = type;
                                oDeviceControlStore.add(oInput);
                            }
                    }
                } else {
                	oDeviceControlStore.add(oNewRecord);
                }
            }
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlAKMDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 239,
            width : 150,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlAKMDevice.parent = this;
        this.grids.lvlAKMDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            var type = record.get('type');
            this.parent.constructGridLvlDeviceAKMValue(dSUID, type);
        });
        this.macPanel.add(this.grids.lvlAKMDevice);
    },
    constructGridLvlAKM: function() {
    	var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('combinedState_zoneAKMStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        this.grids.lvlAKMRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 239,
            width : 150,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlAKMRoom.parent = this;
        this.grids.lvlAKMRoom.on('itemclick', function(grid, record) {

        	this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
        	this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
        	
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlDeviceAKMs(zoneID);
        });
        this.macPanel.add(this.grids.lvlAKMRoom);
    	
    },
    constructgridLvlUDSValue:function(_id) {
    	if (Ext.data.StoreManager.lookup('combinedStateUserStateValue') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'combinedStateUserStateValue',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
    	}
    	Ext.data.StoreManager.lookup('combinedStateUserStateValue').removeAll();
    	
    	var oUserStates=dss.staticDataModel.getUserStates(true);
    		
		for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
			if (oUserStates[iIndex].name==_id) {
				Ext.data.StoreManager.lookup('combinedStateUserStateValue').add({
	                name : oUserStates[iIndex].setName,
	                _id : 'active' ,
	                next : false,
	                icon : dss.staticDataModel.baseImagePath +  "state/uds_state_active.png",
	            });
				Ext.data.StoreManager.lookup('combinedStateUserStateValue').add({
	                name : oUserStates[iIndex].resetName,
	                _id : 'inactive' ,
	                next : false,
	                icon : dss.staticDataModel.baseImagePath +  "state/uds_state_inactive.png",
	            });
			}
		}
            

        this.grids.lvlUserstateValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 239,
            width : 280,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('combinedStateUserStateValue'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlUserstateValue.parent = this;

        this.grids.lvlUserstateValue.on('itemclick', function(grid, record) {
            this.getSelectionModel().deselectAll();
            this.getSelectionModel().select(record);
            if ((this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('type')=='device-sensor-states')||(this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('type')=='zone-sensor-states'))
            	this.parent.takeOver(this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('_id'),record.get('_id'),'system-addon-user-defined-states-special');
            else
            	this.parent.takeOver(this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('_id'),record.get('_id'),'system-addon-user-defined-states');              
        });
        
        this.grids.lvlUserstateValue.on('itemdblclick', function(grid, record) {
            if ((this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('type')=='device-sensor-states')||(this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('type')=='zone-sensor-states'))
            	this.parent.takeOver(this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('_id'),record.get('_id'),'system-addon-user-defined-states-special');
            else
            	this.parent.takeOver(this.parent.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('_id'),record.get('_id'),'system-addon-user-defined-states'); 
        	this.parent.macPanel.collapse();
        });
        
        
        var me=this;
        
        this.macPanel.add(this.grids.lvlUserstateValue);
    	   	
    },
    constructGridLvlUDS: function() {
    	
    	if (Ext.data.StoreManager.lookup('combinedStateUserState') == null) {    		
    		Ext.create('Ext.data.Store', {
                storeId : 'combinedStateUserState',
                fields : [ '_id', 'name', 'next', 'icon','type' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
    	}
    	Ext.data.StoreManager.lookup('combinedStateUserState').removeAll();
    	
    	var oUserStates=dss.staticDataModel.getUserStates(true);
    		
		for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
			Ext.data.StoreManager.lookup('combinedStateUserState').add({
                name : oUserStates[iIndex].displayName,
                _id : oUserStates[iIndex].name ,
                next : true,
                icon : null,
                type: oUserStates[iIndex].type
            });
		}
            

        this.grids.lvlUserstate = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 239,
            width : 250,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('combinedStateUserState'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlUserstate.parent = this;

        this.grids.lvlUserstate.on('itemclick', function(grid, record) {
                this.getSelectionModel().deselectAll();
                this.getSelectionModel().select(record);
                
                this.parent.macPanel.remove(this.parent.grids.lvlUserstateValue);
                this.parent.constructgridLvlUDSValue(record.get('_id'));                
        });
        
        var me=this;
        
        this.macPanel.add(this.grids.lvlUserstate);
    	   	
    },
    constructApartmentSubState: function (id) {
    	var store;
    	if (id==0) 
    		store=Ext.data.StoreManager.lookup('combinedState_daynightStore'); 
    	if (id==1)
    		store=Ext.data.StoreManager.lookup('combinedState_presenceStore');
    	if (id==2) 
    		store=Ext.data.StoreManager.lookup('combinedState_holidayStore');
    	if (id==3) 
    		store=Ext.data.StoreManager.lookup('combinedState_weatherStore');
    	if (id==4) 
    		store=Ext.data.StoreManager.lookup('combinedState_securityStore');
    	if (id==5) 
    		store=Ext.data.StoreManager.lookup('combinedState_climateStore');
    	
        this.grids.lvlApartmentsubstate = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : 239,
            width : 584,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : store,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlApartmentsubstate.parent = this;

        this.grids.lvlApartmentsubstate.on('itemclick', function(grid, record) {
            this.getSelectionModel().deselectAll();
            this.getSelectionModel().select(record);
            this.parent.takeOver(record.get('_id'),record.get('value'),'');     
        });
        
        this.grids.lvlApartmentsubstate.on('itemdblclick', function(grid, record) {
        	this.parent.takeOver(record.get('_id'),record.get('value'),'');
        	this.parent.macPanel.collapse();
        });

        var me=this;
        
        this.macPanel.add(this.grids.lvlApartmentsubstate);
    },
	constructLVL1:function() {
    	this.macPanel.remove(this.grids.lvlUserstate);
    	this.macPanel.remove(this.grids.lvlDeviceAKMValue);
    	this.macPanel.remove(this.grids.lvlAKMDevice);
    	this.macPanel.remove(this.grids.lvlAKMRoom);
    	this.macPanel.remove(this.grids.lvlRoomStateRoom);
    	this.macPanel.remove(this.grids.lvlRoomStateState);
    	this.macPanel.remove(this.grids.lvlUserstateValue);
    	this.macPanel.remove(this.grids.lvlApartmentstate);
    	this.macPanel.remove(this.grids.lvlApartmentsubstate);

		var lvl1Store;
    	if (this.grids.lvl1==null) {
	        var lvl1TempStore = Ext.create('Ext.data.Store', {
	            fields : [ '_id', 'name', 'next', 'icon' ],
	            proxy : {
	                type : 'memory',
	                reader : {
	                    type : 'json',
	                    root : 'items'
	                }
	            }
	        });
	
	        lvl1Store = Ext.data.StoreManager.lookup('combinedStateLVL1');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            lvl1TempStore.add(oNewRecord);
	        });
	        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
	            hideHeaders:true,
	            height : 239,
	            width : 150,
	            autoScroll : true,
	            viewConfig : {
	                stripeRows : true
	            },
	            selModel : {
	                mode : 'MULTI'
	            },
	            store : lvl1TempStore,
	            columns : [ {
	                sortable : false,
	                hideable : false,
	                text : _('Action'),
	                dataIndex : 'name',
	                flex : 1,
	                renderer : this.defMacGridRenderer
	            } ]
	        });
	        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
	        this.grids.lvl1.parent = this;
	
	        this.grids.lvl1.on('itemclick', function(grid, record) {
	        	this.parent.macPanel.remove(this.parent.grids.lvlUserstate);
	        	this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
	        	this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
	        	this.parent.macPanel.remove(this.parent.grids.lvlAKMRoom);
	        	this.parent.macPanel.remove(this.parent.grids.lvlRoomStateRoom);
	        	this.parent.macPanel.remove(this.parent.grids.lvlRoomStateState);
	        	this.parent.macPanel.remove(this.parent.grids.lvlUserstateValue);
	        	this.parent.macPanel.remove(this.parent.grids.lvlApartmentstate);
	        	this.parent.macPanel.remove(this.parent.grids.lvlApartmentsubstate);
                var fIsPassive=false;
	            if (record.get('passive')!=null) {
	                if (record.get('passive')==true) {
	                    this.getSelectionModel().deselect(record);
	                    fIsPassive=true;
	                }
	            }
	            if (!fIsPassive) {
	                if (record.get('_id') == 0) { // zone states
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlRoom();
	                } else if (record.get('_id') == 1) { // akm
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlAKM();
	                } else if (record.get('_id') == 2) { // uds
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlUDS();
	                } else if (record.get('_id') == 3) { // weather
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructApartmentSubState(3);                
	                } else if (record.get('_id') == 4) { // sicherheit
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructApartmentSubState(4);                
	                } else if (record.get('_id') == 5) { // sonne
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructApartmentSubState(0);                
	                } else if (record.get('_id') == 6) { // presence
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructApartmentSubState(1);                
	                } else if (record.get('_id') == 7) { // holiday
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructApartmentSubState(2);                
	                }
	            }
	            this.parent.macPanel.doLayout();
	        }); 
	        this.macPanel.add(this.grids.lvl1);
    	} else {
        	this.grids.lvl1.getStore().removeAll();
        	var mThis=this;        	
	        lvl1Store = Ext.data.StoreManager.lookup('combinedStateLVL1');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            mThis.grids.lvl1.getStore().add(oNewRecord);
	        });
        	this.macPanel.remove(this.grids.lvlUserstate);
        	this.macPanel.remove(this.grids.lvlDeviceAKMValue);
        	this.macPanel.remove(this.grids.lvlAKMDevice);
        	this.macPanel.remove(this.grids.lvlAKMRoom);
        	this.macPanel.remove(this.grids.lvlRoomStateRoom);
        	this.macPanel.remove(this.grids.lvlRoomStateState);
        	this.macPanel.remove(this.grids.lvlUserstateValue);
        	this.macPanel.remove(this.grids.lvlApartmentstate);
        	this.macPanel.remove(this.grids.lvlApartmentsubstate);
    	}
		
	},
    getStateGridTextActive : function(scene)
	{
	    var scene_name = dss.staticDataModel.getNameForScene(0, 0, scene);
	    var gridTextActive = Ext.String.format2(_("only when {name} is active"), {'name': scene_name});
	    return gridTextActive;
	},
	getStateGridTextInactive : function (scene)
	{
	    var scene_name = dss.staticDataModel.getNameForScene(0, 0, scene);
	    var gridTextInactive = Ext.String.format2(_("only when {name} is inactive"), {'name': scene_name});
	    return gridTextInactive;
	},
	initStores : function () {	

		/*Sonnenstand
		 * anwesenheit
		 * anwesenheitsimulation
		 * wetter
		 * sicherheit
		 * heizungssystem*/
		
		if (Ext.data.StoreManager.lookup('combinedState_daynightStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_daynightStore',
                fields : [ '_id', 'name', 'value','icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        	Ext.data.StoreManager.lookup('combinedState_daynightStore').add([
   				{_id:'daylight_state',name:Ext.String.format2(_('daynight_bright'),{
	                    duskTime:dss.staticDataModel.getDusk(),
	                    dawnTime:dss.staticDataModel.getDawn()
	                }),value:'active',icon:dss.staticDataModel.getImagePathForState('daylight',true)},
  				{_id:'daylight_state',name:Ext.String.format2(_('daynight_dark'),{
	                    duskTime:dss.staticDataModel.getDusk(),
	                    dawnTime:dss.staticDataModel.getDawn()
	                }),value:'inactive',icon:dss.staticDataModel.getImagePathForState('daylight',false)},
  				{_id:'daynight_state',name:Ext.String.format2(_('daynight_day'),{
	                    sunriseTime:dss.staticDataModel.getSunrise(),
	                    sunsetTime:dss.staticDataModel.getSunset()
	                }),value:'active',icon:dss.staticDataModel.getImagePathForState('daynight',true)},
  				{_id:'daynight_state',name:Ext.String.format2(_('daynight_night'),{
	                    sunriseTime:dss.staticDataModel.getSunrise(),
	                    sunsetTime:dss.staticDataModel.getSunset()
	                }),value:'inactive',icon:dss.staticDataModel.getImagePathForState('daynight',false)}]); 
		}
		if (Ext.data.StoreManager.lookup('combinedState_presenceStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_presenceStore',
                fields : [ '_id', 'name', 'value','icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        	Ext.data.StoreManager.lookup('combinedState_presenceStore').add([
 				{_id:'presence',name:_('presence_present'),value:'present',icon:dss.staticDataModel.getImagePathForState('presence','present')},
 				{_id:'presence',name:_('presence_absent'),value:'absent',icon:dss.staticDataModel.getImagePathForState('presence','absent')}]); 
		}
		if (Ext.data.StoreManager.lookup('combinedState_holidayStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_holidayStore',
                fields : [ '_id', 'name', 'value','icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        	Ext.data.StoreManager.lookup('combinedState_holidayStore').add([
 				{_id:'holiday',name:_('holiday_on'),value:'on',icon:dss.staticDataModel.getImagePathForState('holiday','on')},
 				{_id:'holiday',name:_('holiday_off'),value:'off',icon:dss.staticDataModel.getImagePathForState('holiday','off')}]); 
		}
		if (Ext.data.StoreManager.lookup('combinedState_weatherStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_weatherStore',
                fields : [ '_id', 'name', 'value','icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        	Ext.data.StoreManager.lookup('combinedState_weatherStore').add([
 				{_id:'rain',name:_('rain active'),value:'active',icon:dss.staticDataModel.getImagePathForState('rain','1')},
 				{_id:'rain',name:_('rain inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('rain','2')},
 				{_id:'wind',name:_('wind active'),value:'active',icon:dss.staticDataModel.getImagePathForState('wind','1')},
 				{_id:'wind',name:_('wind inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('wind','2')},
 				{_id:'hail',name:_('hail active'),value:'active',icon:dss.staticDataModel.getImagePathForState('hail','1')},
 				{_id:'hail',name:_('hail inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('hail','2')},
 				{_id:'frost',name:_('frost active'),value:'active',icon:dss.staticDataModel.getImagePathForState('frost','1')},
 				{_id:'frost',name:_('frost inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('frost','2')},
 				{_id:'sun',name:_('sun active'),value:'active',icon:dss.staticDataModel.getImagePathForState('sun','1')},
 				{_id:'sun',name:_('sun inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('sun','2')},
 				{_id:'service',name:_('service active'),value:'active',icon:dss.staticDataModel.getImagePathForState('service','1')},
 				{_id:'service',name:_('service inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('service','2')}]);                        
		}
		if (Ext.data.StoreManager.lookup('combinedState_securityStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_securityStore',
                fields : [ '_id', 'name', 'value','icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        	Ext.data.StoreManager.lookup('combinedState_securityStore').add([
				{_id:'fire',name:_('fire active'),value:'active',icon:dss.staticDataModel.getImagePathForState('fire','1')},
				{_id:'fire',name:_('fire inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('fire','2')},
				{_id:'panic',name:_('panic_active'),value:'active',icon:dss.staticDataModel.getImagePathForState('panic','1')},
				{_id:'panic',name:_('panic_inactive'),value:'inactive',icon:dss.staticDataModel.getImagePathForState('panic','2')},
				{_id:'alarm',name:this.getStateGridTextActive(74),value:'active',icon:dss.staticDataModel.getImagePathForState('alarm','1')},
				{_id:'alarm',name:this.getStateGridTextInactive(74),value:'inactive',icon:dss.staticDataModel.getImagePathForState('alarm','2')},
				{_id:'alarm2',name:this.getStateGridTextActive(83),value:'active',icon:dss.staticDataModel.getImagePathForState('alarm2','1')},
				{_id:'alarm2',name:this.getStateGridTextInactive(83),value:'inactive',icon:dss.staticDataModel.getImagePathForState('alarm2','2')},
				{_id:'alarm3',name:this.getStateGridTextActive(84),value:'active',icon:dss.staticDataModel.getImagePathForState('alarm3','1')},
				{_id:'alarm3',name:this.getStateGridTextInactive(84),value:'inactive',icon:dss.staticDataModel.getImagePathForState('alarm3','2')},
				{_id:'alarm4',name:this.getStateGridTextActive(85),value:'active',icon:dss.staticDataModel.getImagePathForState('alarm4','1')},
				{_id:'alarm4',name:this.getStateGridTextInactive(85),value:'inactive',icon:dss.staticDataModel.getImagePathForState('alarm4','2')}]);                        
		}
		if (Ext.data.StoreManager.lookup('combinedState_climateStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_climateStore',
                fields : [  '_id', 'name', 'value','icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var climateSettings = dss.staticDataModel.getClimateSettings();
            if (climateSettings != null && climateSettings.capabilities != null && climateSettings.capabilities.coolingSupported == true) {
            	Ext.data.StoreManager.lookup('combinedState_climateStore').add([
            	     {_id:'climate',name:_('off'),value:'off',icon:dss.staticDataModel.getImagePathForState('heating_water_system','0')},
            	     {_id:'climate',name:_('heating on'),value:'heating',icon:dss.staticDataModel.getImagePathForState('heating_water_system','1')},
            	     {_id:'climate',name:_('cooling on'),value:'cooling',icon:dss.staticDataModel.getImagePathForState('heating_water_system','2')}]);
                
            } else {
            	Ext.data.StoreManager.lookup('combinedState_climateStore').add([
             	     {_id:'climate',name:_('off'),value:'off',icon:dss.staticDataModel.getImagePathForState('heating_water_system','0')},
             	     {_id:'climate',name:_('heating on'),value:'heating',icon:dss.staticDataModel.getImagePathForState('heating_water_system','1')}]);
            }
           

		}
		
        if (Ext.data.StoreManager.lookup('combinedState_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('combinedState_zoneStore').add(dss.staticDataModel.getZoneArray());
        }
		
        if (Ext.data.StoreManager.lookup('combinedState_zoneAKMStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'combinedState_zoneAKMStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oArray=dss.staticDataModel.getZoneArray();
            var deviceArray=dss.staticDataModel.getAKMDeviceArray();
            for (var iIndex=0;iIndex<oArray.length;iIndex++) {
                var fAdd=false;                
                for (var jIndex=0;jIndex<deviceArray.length;jIndex++) {
                    if (deviceArray[jIndex].ZoneID==oArray[iIndex].ZoneID)
                        fAdd=true;
                }                    
                if (fAdd) {
                    Ext.data.StoreManager.lookup('combinedState_zoneAKMStore').add(oArray[iIndex]);
                }
            }
        }
		
		if (Ext.data.StoreManager.lookup('combinedStateLVL1') == null) {
            var Aktionen = [{
                name : _('zone states'),
                _id : 0,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }, {
                name : _('automatic devices'),
                _id : 1,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getAKMDeviceArray().length==0)
            }, {
                name : _('user def. states'),
                _id : 2,
                next : true,
                icon : null,
                passive:(dss.staticDataModel.getUserStates().length==0)
            }, {
                name : '-',
                _id : -1,
                next : false,
                icon : null,
                passive:true
            }, {
                name : _('weather trigger'),
                _id : 3,
                next : true,
                icon : null,
                passive:false
            }, {
                name : _('Security'),
                _id : 4,
                next : true,
                icon : null,
                passive:false
            }, {
                name : _('state_daynight'),
                _id : 5,
                next : true,
                icon : null,
                passive:false
            }, {
                name : _('state_presence'),
                _id : 6,
                next : true,
                icon : null,
                passive:false
            }, {
                name : _('state_holiday'),
                _id : 7,
                next : true,
                icon : null,
                passive:false
            }];
            
            Ext.create('Ext.data.Store', {
                storeId : 'combinedStateLVL1',
                fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('combinedStateLVL1').add(Aktionen);
            
        }
        		
		if (Ext.data.StoreManager.lookup('stateCombined') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'stateCombined',
                fields : [ 'number','state','value','addonid'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        }	
		Ext.data.StoreManager.lookup('stateCombined').removeAll();
	},
	setEditor:function(oRecord) {
		this.startEdit();
		if (oRecord.get('addonid')=='') {
			if (oRecord.get('state').substr(0,4)=='dev.') {
				
				// AKM 
				this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);
				this.constructGridLvlAKM();
				var dsid=oRecord.get('state').split('.')[1];
				var oDevice=dss.staticDataModel.getDevice(dsid);
				
				var typeIndex=parseInt(oRecord.get('state').split('.')[2],10);
	            var type=255;
	            if (oDevice.binaryInputs!=null)
	            	for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
	            		if (oDevice.binaryInputs[kIndex].index==typeIndex)
	            			type=oDevice.binaryInputs[kIndex].type;
	            
				var oRoom=this.grids.lvlAKMRoom.store.find('ZoneID',oDevice.ZoneID,false,false,true);
				if (oRoom!=-1) {
					this.grids.lvlAKMRoom.getSelectionModel().select(oRoom,true);
					this.constructGridLvlDeviceAKMs(oDevice.ZoneID);
					var iDevice=this.grids.lvlAKMDevice.store.find('dSUID',dsid,false,false,true);					
					if (iDevice!=-1) {
						this.grids.lvlAKMDevice.getSelectionModel().select(iDevice,true);
						this.constructGridLvlDeviceAKMValue(dsid, type);
						var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);
						if (!bIsWindowHandle) {
							var oValue=this.grids.lvlDeviceAKMValue.store.find('_id',(oRecord.get('value')=='active'),false,false,true);
							if (oValue!=-1)
								this.grids.lvlDeviceAKMValue.getSelectionModel().select(oValue,true);
						} else {
							var stateValue=dss.whState.WH_Closed;
							if (oRecord.get('value')=='open')
								stateValue=dss.whState.WH_Open;
							if (oRecord.get('value')=='tilted')
								stateValue=dss.whState.WH_Tilted;							
							var oValue=this.grids.lvlDeviceAKMValue.store.find('_id',stateValue,false,false,true);
							if (oValue!=-1)
								this.grids.lvlDeviceAKMValue.getSelectionModel().select(oValue,true);							
						}
					}
				}						
			} else if (oRecord.get('state').substr(0,5)=='zone.') {
					var zoneID=parseInt("" + (oRecord.get('state').split('.')[1]),10);
					this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',0,false,false,true),true);
					this.constructGridLvlRoom();
					var oRoom=this.grids.lvlRoomStateRoom.store.find('ZoneID',zoneID,false,false,true);
					if (oRoom!=-1) {
						this.grids.lvlRoomStateRoom.getSelectionModel().select(oRoom,true);
						this.constructGridLvlRoomStateState(zoneID);
						var pState=-1;
						var storeState=this.grids.lvlRoomStateState.store;
						for (var iIndex=0;iIndex<storeState.count();iIndex++) {
							var oSubRecord=storeState.getAt(iIndex);
							if (oSubRecord.get('value')==oRecord.get('value'))
								if (oSubRecord.get('stateid')==oRecord.get('state'))
									this.grids.lvlRoomStateState.getSelectionModel().select(iIndex,true);
						}
					}
			} else {
				switch (oRecord.get('state')) {
					case 'rain':
					case 'wind':
					case 'hail':
					case 'frost':
					case 'sun':
					case 'service':
						this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',3,false,false,true),true);
						this.constructApartmentSubState(3);
					break;
					
					case 'daylight_state':
					case 'daynight_state':
						this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',5,false,false,true),true);
						this.constructApartmentSubState(0);
					break;
					
					case 'presence':
						this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);
						this.constructApartmentSubState(6);
					break;
					
					case 'holiday':
						this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',7,false,false,true),true);
						this.constructApartmentSubState(7);
					break;
					
					case 'fire':
					case 'panic':
					case 'alarm':
					case 'alarm2':
					case 'alarm3':
					case 'alarm4':
						this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',4,false,false,true),true);
						this.constructApartmentSubState(4);
					break;					
				}
				
				var storeState=this.grids.lvlApartmentsubstate.store;
				for (var iIndex=0;iIndex<storeState.count();iIndex++) {
					var oSubRecord=storeState.getAt(iIndex);
					if (oSubRecord.get('value')==oRecord.get('value'))
						if (oSubRecord.get('_id')==oRecord.get('state'))
							this.grids.lvlApartmentsubstate.getSelectionModel().select(iIndex,true);
				}
			}
		} else {
			// custom state
			this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',2,false,false,true),true);
            this.constructGridLvlUDS();
            var oState=this.grids.lvlUserstate.store.find('_id',oRecord.get('state'),false,false,true);
            if (oState != -1) {
            	this.grids.lvlUserstate.getSelectionModel().select(oState,true);
            	this.constructgridLvlUDSValue(oRecord.get('state'));
            	var oValue=this.grids.lvlUserstateValue.store.find('_id',oRecord.get('value'),false,false,true);
            	if (oValue!=-1)
            		this.grids.lvlUserstateValue.getSelectionModel().select(oValue,true);
            }
		}
        this.selectedID=oRecord.get('number');
	},
	getStateString:function(value,state) {

    	var oUserStates=dss.staticDataModel.getUserStates(true)
    	
    	for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
			if (oUserStates[iIndex].name==state) {
				if (value=='active') {
					return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.baseImagePath + 'state/uds_state_active.png"></td><td>' + 
						Ext.String.format2(_('Customstate {state} is {value}'),{state:oUserStates[iIndex].displayName,value:oUserStates[iIndex].setName})+ '</td></tr></table>';
				}
				if (value=='inactive') {
					return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.baseImagePath + 'state/uds_state_inactive.png"></td><td>' + 
						Ext.String.format2(_('Customstate {state} is {value}'),{state:oUserStates[iIndex].displayName,value:oUserStates[iIndex].resetName}) + '</td></tr></table>';
				}
			}
		}
    	var oArray=state.split('.');
    	if (oArray[0]=='dev') {
    		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
    		if (oDevice!=null) {
                var typeIndex=parseInt(oArray[2],10);
                var type=255;
                if (oDevice.binaryInputs!=null)
                    for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
                    	if (oDevice.binaryInputs[kIndex].index==typeIndex)
                    		type=oDevice.binaryInputs[kIndex].type;
                var oParameter={
                    	device:oDevice.name,
                    	zone_of_device:dss.staticDataModel.getNameForZone(oDevice.ZoneID)
                    };

                var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);
                if (bIsWindowHandle) {
                	if (value=='closed')
                		oParameter.state_value = dss.staticDataModel.getNameForAKMValue(type,dss.whState.WH_Closed);
                	if (value=='open')
                		oParameter.state_value = dss.staticDataModel.getNameForAKMValue(type,dss.whState.WH_Open);
                	if (value=='tilted')
                		oParameter.state_value = dss.staticDataModel.getNameForAKMValue(type,dss.whState.WH_Tilted);
                } else {
                    if (value=='active') {
                        oParameter.state_value = dss.staticDataModel.getNameForAKMValue(type,true);
                    } else {
                        oParameter.state_value = dss.staticDataModel.getNameForAKMValue(type,false);
                    }
                }

                var sString = Ext.String.format2(_("{#grid_condition_column_akm_state}{state_value} on {device} in {zone_of_device}"),oParameter);
                                                
                return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + '</td></tr></table>';
    		}
    	}
    	
    	
    	if (oArray[0]=='zone') {
    		var sNameOfZone=dss.staticDataModel.getNameForZone(parseInt(oArray[1],10));
    		if (oArray[2]=='light') {
    			if (value=='active') {
    			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}light in {zone} is on"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,5) + '"></td><td>'+ sString + '</td></tr></table>';		                					                            	
    			} else {
    			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}light in {zone} is off"),{'zone':sNameOfZone});
    			    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,0) + '"></td><td>' + sString + '</td></tr></table>';	        					                            	
    			}
    		} else
    		if (oArray[2]=='motion') {
    			if (value=='active') {
    			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}motion in {zone} is reported"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(5,true) + '"></td><td>'+ sString + '</td></tr></table>';		                					                            	
    			} else {
    			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}no motion in {zone} is reported"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(5,false) + '"></td><td>' + sString + '</td></tr></table>';	        					                            	
    			}
    		} else
            if (oArray[2]=='presence') {
                if (value=='active') {
                    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}presence in {zone} is reported"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(1,true) + '"></td><td>'+ sString + '</td></tr></table>';		                					                            	
                } else {
                    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}absence in {zone} is reported"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(1,false) + '"></td><td>' + sString + '</td></tr></table>';	        					                            	
                }
                
            } else
            if (oArray[2]=='heating') {
                if (value=='active') {
                    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}heating in {zone} is activ"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(1,true) + '"></td><td>'+ sString + '</td></tr></table>';		                					                            	
                } else {
                    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}heating in {zone} is inactiv"),{'zone':sNameOfZone});
                    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(1,false) + '"></td><td>' + sString + '</td></tr></table>';	        					                            	
                }
            }
    	}

		return '<table><tr><td style="padding-right:5px;"><img src="'+dss.staticDataModel.getImagePathForState(state,value)+'"></td><td>' + _('grid_' + state+'_'+value) + '</td></tr></table>'; 
    	
    	return value + " " + state;
	},
	constructor : function(config) {		
		var me=this;
    	this.initStores();
    	this.grids={};
		this.oButtonNew = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Add state'),
            disabled : false,
            handler : function() {  
            	me.startEdit();            	
            }
        });
		this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Edit state'),
            disabled : true,
            handler : function() {
            	var oSelected=me.grid.getSelectionModel().getSelection();
            	if (oSelected.length==1) {
            		var oRecord=oSelected[0];
            		me.setEditor(oRecord);
            	}
            }
        });
		this.oButtonShow = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Show all states'),
            hidden:true,
            handler : function() {
            	me.macPanel.collapse();
            }
        });
		this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('Delete state'),
            disabled : true,
            handler : function() {
            	var oSelected=me.grid.getSelectionModel().getSelection();
            	if (oSelected.length>0) {
            		for (var iIndex=0;iIndex<oSelected.length;iIndex++) {
            			me.grid.store.remove(oSelected[iIndex]);
            			
            		}
            	}
            }
        });
    	
		this.grid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            border : '0',
            region : 'center',
            store : Ext.data.StoreManager.lookup('stateCombined'),
            hideHeaders : true,
            overflowX:'hidden',                
            width: 736,
            height : 206,
       		viewConfig : {
                stripeRows : true
            },
            columns : [{
                dataIndex : 'value',
                sortable : false,
                hideable : false,
                flex:1,
                renderer: function (val, metadata, record, colIdx, store, view) {
                	return me.getStateString(record.get('value'),record.get('state'));
                }
            }],
                
            tbar : [ this.oButtonNew, this.oButtonEdit, this.oButtonShow, '->', this.oButtonDelete ]
        });

		this.grid.on("selectionchange",function () {
			if (me.grid.getSelectionModel().getSelection().length>0) {
				me.oButtonEdit.setDisabled(false);
				me.oButtonDelete.setDisabled(false);
			} else {
				me.oButtonEdit.setDisabled(true);
				me.oButtonDelete.setDisabled(true);
			}
		});
        this.grid.on("itemdblclick",function (grid, record) {
        	me.setEditor(record);
		});
    	
		this.macPanel=Ext.create('Ext.panel.Panel', {		
			border : '0',
			autoScroll : true,
            animCollapse : true,           
			title:' ',
			header:false,
			region : 'south',
			items : [  ],
            collapsible : true,
            collapsed : true,
			height: 241,
			width:734,
			hideCollapseTool:true,
	        layout : {
	            type : 'hbox'
	        },
        	scroll : 'horizontal',
        	listeners: {
        		collapse: function () {
        			me.oButtonEdit.setVisible(true);
        			me.oButtonShow.setVisible(false);
        		},
        		expand: function () {
        			me.oButtonEdit.setVisible(false);
        			me.oButtonShow.setVisible(true);
        		},
        	}
		});
		
		this.baseTab=Ext.create('Ext.panel.Panel', {		
			items : [ this.grid,this.macPanel ],
			height: 272,
			width:738,
			layout: {
				type: 'border'
			}
		});

    	Ext.apply(this, {
        	border: 0,
  			items : [ this.baseTab ],
  			height: 300,
  			width:740,
  			layout: {
  				type: 'vbox'
  			}
  		});
        
  		this.callParent(arguments);
	},
	reset : function() {
		this.grid.store.removeAll();
    	this.macPanel.collapse();
		this.baseTab.getEl().child('.x-panel-body').applyStyles('border: solid 1px #99e8bc;');
		this.operationSelector=this.dssEditor.editControls['combinedNames'].operationSelector;
		this.initStores();
	},
	isValid : function() {
		if (this.isHidden())
			return true;
		if (this.grid.store.count()<1) {
			this.baseTab.getEl().child('.x-panel-body').applyStyles('border: solid 1px red');
			return false;
		} else {
			this.baseTab.getEl().child('.x-panel-body').applyStyles('border: solid 1px #99e8bc;');
			return true;
		}
	},
	setValue : function(oValue) {
		this.reset();
		var oArray=[];
		if (oValue.or!=null) {
			this.operationSelector.setValue({operator:'or'});
			for (var iIndex=0;iIndex<oValue.or.length;iIndex++) {
				oArray.push({ 
					'number':iIndex,
					'state':oValue.or[iIndex].state,
					'value':oValue.or[iIndex].value,
					'addonid':oValue.or[iIndex].addonid});
			}
		} else {
			this.operationSelector.setValue({operator:'and'});
			for (var iIndex=0;iIndex<oValue.and.length;iIndex++) {
				oArray.push({ 
					'number':iIndex,
					'state':oValue.and[iIndex].state,
					'value':oValue.and[iIndex].value,
					'addonid':oValue.and[iIndex].addonid});
			}
		}
		this.grid.store.add(oArray);
	},
	getValue : function() {
		var returnObject={};
		var oArray=[];
		for (var iIndex=0;iIndex<this.grid.store.count();iIndex++) {
			oArray.push({
				state:this.grid.store.getAt(iIndex).get('state'),
				value:this.grid.store.getAt(iIndex).get('value'),
				addonid:this.grid.store.getAt(iIndex).get('addonid'),
			});
		}
				
		if (this.operationSelector.getValue().operator=='or')
			returnObject.or=oArray;
		if (this.operationSelector.getValue().operator=='and')
			returnObject.and=oArray;
		return returnObject;
	}
});